import stream;
import string;

extern (C) {
	char* getenv(char *name);
}

int main() {
	char* q = getenv("QUERY_STRING");

	if (q && *q) {
		char[] query = string.toString(q);
		char[][char[]] qm;
		foreach (char[] elm; string.split(query, "&")) {
			int idx = string.find(elm, "=");
			if (idx != -1) {
				qm[elm[0..idx]] = elm[idx+1..elm.length];
			}
		}

		stream.stdout.writeLine(
			"Content-Type: text/html\r\n" ~
			"\r\n" ~
			"hello, " ~ qm["name"] ~ ".");
	}
	else {
		stream.stdout.writeLine(
			"Content-Type: text/html\r\n" ~
			"\r\n" ~
			"what's your name?<br>" ~
			"<form>" ~
			"<input name=\"name\">" ~
			"<input type=\"submit\">" ~
			"</form>");
	}

	return 0;
}
