private import response;

class TypicalResponses {
public:
    static HttpResponse response(char[] status, char[] msg) {
        HttpResponse res =
            new HttpResponse("HTTP/1.0 " ~ status);
        res.messageBody =
            "<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\">"
            "<HTML><HEAD>"
            "<TITLE>" ~ status ~ "</TITLE>"
            "</HEAD><BODY>"
            "<H1>" ~ status ~ "</H1>" ~ msg;
        res.header["Content-Type"] = "text/html";
        res.addDefaultHeader();
        return res;
    }

	static HttpResponse resOK(char[] msg) {
        return response(`200 OK`, msg);
    }
	static HttpResponse resOK() {
        return resInternalServerError(``);
    }
	static HttpResponse resInternalServerError(char[] msg) {
        return response(`500 Internal Server Error`, msg);
    }
	static HttpResponse resInternalServerError() {
        return resInternalServerError(``);
    }
	static HttpResponse resNotFound(char[] msg) {
        return response(`404 Not Found`, msg);
    }
	static HttpResponse resNotFound() {
        return resNotFound(``);
    }
	static HttpResponse resForbidden(char[] msg) {
        return response(`403 Forbidden`, msg);
    }
	static HttpResponse resForbidden() {
        return resForbidden(``);
    }
    static HttpResponse resProxyError(char[] msg) {
        return response(`500 Proxy Error`, msg);
    }
    static HttpResponse resProxyError() {
        return resProxyError(``);
    }
}

